;
;
;                            Belch Math v.4.65
;
; Date:         July 21, 2003
;
; Info: Originally written in basic, this helpful math utility has been
;       converted to ASM.


#include "Asm86.h"                  ;flags, key equates...
#include "Ram86.h"                  ;memory locations
#include "Rom86.h"                  ;ROM calls

;.plugin lite86;                     ;the ultimate compression rutine

_ioprompt   =$c324
_asap_ind   =$d623
_getcode    =$4068

.org _asm_exec_ram 

    nop                             ;no operation so...
    jp Start                        ;jump to Start
    .dw 0                           ;type of input
    .dw String1                     ;print string

String1:    .db "Belch Math v.4.65",0

Start:
    call _flushallmenus             ;clears all key codes
    call _runindicon                ;turn off run indicator
    call _clrScrn                   ;clears the lcd and graph screen
    ld hl,(256*1)+3                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String1                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String2                   ;string to print
    ld bc,256*58+8                  ;column 5, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine2
GetKey1:
    call _getcode                   ;stores key pressed into a
    cp K_EXIT                       ;compares a with EXIT
    jp z,Exit                       ;if EXIT jump to Exit
    cp K_F1                         ;compares a with F1
    jr z,Volume                     ;if F1 jump to VAR1
    cp K_F2                         ;compares a with F2
    jr z,Slope                      ;if F2 jump to VAR2
    cp K_F3                         ;compares a with F3
    jp z,Pyth                       ;if F2 jump to VAR3
    cp K_F4                         ;compares a with F4
    jp z,Info                       ;if F2 jump to VAR2
    cp K_F5                         ;compares a with F5
    jp z,Exit                       ;if F2 jump to Exit
    cp K_UP                         ;compares a with UP
    jp z,Stuff                      ;if UP jump to stuff
    jr GetKey1                      ;relative jump to GetKey1

Volume:
    ld hl,Prgm1-1                   ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jp c,PrgmGone                   ;if not jump to PrgmGone
    call _exec_assembly             ;execute prgm in op1
    jr Start                        ;jumps to Start

Slope:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;sets hl with coordinates (0,0)
    ld hl,E1                        ;loads hl with string
    call Input                      ;goes to Input
    ld hl,E2                        ;loads hl with string
    call Input                      ;goes to Input
    call _stoX                      ;stores op1(x1) to real variable x
    ld hl,E3                        ;load hl with string
    call Input                      ;goes to Input
    call _stoY                      ;stores op1(y1) to real variable y
    ld hl,E4                        ;load hl with string
    call Input                      ;goes to Input
    rst 08h                         ;op1(x2) is copied to op2
    call _rclX                      ;recalls real variable x(x1) to op1
    call _FPSUB                     ;op1(x1) - op2(x2) ==> op1
    call _op1toop4                  ;op1(x1-x2) is copied to op4
    xor a                           ;loads a with 0
    call _setXXop2                  ;move value of a(0) to op2
    call _cpop1op2                  ;compare op1(x1-x2) to op2(0)
    jp z,Error                      ;if equal jump to Error
    ld hl,E5                        ;load hl with string
    call Input                      ;goes to Input
    rst 08h                         ;op1(y2) is copied to op2
    call _rclY                      ;recall real variable y(y1) to op1
    call _FPSUB                     ;op1(y1) - op2(y2) ==> op1
    call _op4toop2                  ;op4(x1-x2) is copied to op2
    call _FPDIV                     ;op1(y1-y2) / op2(x1-x2) ==> op1
    ld hl,(256*0)+4                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String5                   ;loads hl with string
    call _puts                      ;print string
    call DispAnswer                 ;goes to DispAnswer
    rst 08h                         ;op1(slope) ==> op2
    call _rclX                      ;recall real variable x(x1) to op1
    rst 28h                         ;op1(x1) * op2(slope) ==> op1
    rst 08h                         ;op1(x1) * slope) ==> op2
    call _rclY                      ;recall real variable y(y1) to op1
    call _FPSUB                     ;op1(y1) - op2(x1 * slope) ==> op1
    ld hl,(256*0)+6                 ;loads coordinates into hl, row 2, col 3
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String6                   ;loads hl with string
    call _puts                      ;print string
    call DispAnswer                 ;goes to DispAnswer
    call _getkey                    ;pauses program until a key is pressed
    jp Start                        ;jumps to Start

Pyth:
    ld hl,Prgm2-1                   ;loads hl with prgm name to execute
    rst 20h                         ;op1 = name of 2nd asm prog to call
    rst 10h                         ;call _findsym, see if variable exists
    jr c,PrgmGone                   ;if not jump to PrgmGone
    jp _exec_assembly               ;execute prgm in op1

Info:
    call _clrScrn                   ;clears the lcd and graph screen
    ld hl,(256*0)+0                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String8                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*0)+2                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String9                   ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*12)+3                ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String10                  ;loads hl with string
    call _puts                      ;print string
    ld hl,(256*0)+5                 ;loads coordinates into hl
    ld (_curRow),hl                 ;loads _curRow with hl
    ld hl,String11                  ;loads hl with string
    call _puts                      ;print string
    call _getkey                    ;pauses program until a key is pressed
    jp Start                        ;jumps to Start

Error:
    call _clrScrn                   ;clears the lcd and graph screen
    call _homeup                    ;move to upper left
    ld hl,String7                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String4                   ;string to print
    ld bc,256*58+106                ;column 107, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine2
    call _runindicoff               ;turn off run indicator
    call _getkey                    ;waits for a key to be pressed
    call _clrScrn                   ;clears the lcd and graph screen
    ret                             ;exit the program

PrgmGone:
    call _clrScrn                   ;clears the lcd and graph screen
    call _homeup                    ;move to upper left
    ld hl,String3                   ;loads hl with string
    call _puts                      ;print string
    ld hl,String4                   ;string to print
    ld bc,256*58+106                ;column 107, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call MenuRoutine1               ;goes to MenuRoutine2
    call _runindicoff               ;turn off run indicator
    call _getkey                    ;waits for a key to be pressed
    call _clrScrn                   ;clears the lcd and graph screen
    ret                             ;exit the program

Input:
    ld de,_ioprompt                 ;$c324 - string storage for display when prompte
    call _mov10b                    ;$427b - move 10 bytes from hl to de
    ld a,$0d                        ;type of input
                                    ;$0d - # value
                                    ;$0c - string
    ld (_asap_ind),a                ;$d623 - tell ti86 what kind to be inputted
    jp _exec_pg3                    ;$5714 - ti86 os input
                                    ;the number inputted is always stored to OP1
    ret                             ;return to call

Stuff:
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ld hl,String12                  ;string to print
    ld bc,256*32+0                  ;column 107, row 59
    ld (_penCol),bc                 ;loads c into _penCol
    call _vputs                     ;print it and return
    call _getkey                    ;waits for a key to be pressed
    jp Start                        ;goes to Start

DispAnswer:
    ld a,48                         ;loads a with 48
    call _formReal                  ;forms answer to real #
    ld hl,_OP3                      ;loads answer into hl
    call _puts                      ;prints answer
    ret                             ;return to call

Exit:
    res 3,(iy+5)                    ;reverts text back to black on white
    call _clrScrn                   ;clears lcd and graph screen
    call _homeup                    ;moves cursor to upper left
    ret                             ;return that exits the program

#include "Menu86.asm"

String2:    .db "Vol          Slope        Pyth           Info            Exit",0
String3:    .db "ERROR 14 UNDEFINED",0
String4:    .db "QUIT",0
String5:    .db "Slope: "0
String6:    .db "Y-cept: ",0
String7:    .db "ERROR 02 DIV BY ZERO",0
String8:    .db 187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,0
String9:    .db "Created By: Nick",0
String10:   .db "Kariniemi",0
String11:   .db 187,187,187," Copyright 2002 ",187,187,187,187,187," NKProductions ",187,187,187," ",187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,187,0
String12:   .db 65,83,77,32,118,101,114,115,105,110,32,119,114,105,116,116,101,110,32,98,121,32,77,111,114,103,97,110,32,68,97,118,105,101,115,33,33,33,0
Prgm1:      .db 7,"Volume2"
Prgm2:      .db 6,"Pythag"
E1:     .db "Round to:",0
E2:     .db "Point 1 x:",0
E3:     .db "Point 1 y:",0
E4:     .db "Point 2 x:",0
E5:     .db "Point 2 y:",0

.end
END